#property library   
 
#import "AG_Lib.ex4"
   int AG_Magic_Number();                          //  MN 
   int AG_Message(string& Message[], string _Text);//     Message[]
#import

bool FatalError, FreeMarginAlert;
datetime LastBar = 0;
double Spread, StopLevel, TP, SL, Lots, Koeff, Tick,
       UpFractal1, DownFractal1, UpFractal2, DownFractal2;
int Signal, MagicNumber, TU1, TU2, TD1, TD2;
int FastMACD = 12;
int SlowMACD = 26;
int SignalMACD = 9;
string Comm = "AG_AT";                          //  ( "AG_AT")

int AG_AT(int Parol_AT, double Order[][], string Object[], double Instrument[][][][], 
          int Ddraw_Object[][], double& Tuning[], double& Manager[][], string& Message[])
   {    
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   Lots = NormalizeDouble(Tuning[1],2);       //  
   int Slip  = NormalizeDouble(Tuning[3],0);       //  ()
// ------------    ---------------------------------------------
   Koeff = NormalizeDouble(Instrument[0][0][1][0], 0);  // AT_1
   if (Koeff <= 0) Koeff = 0.85;
   int MagicNumber = Period();
// --------------------------------------------------------------------------------------   
// - 1 -  ==    ? ===========================================
   if (FatalError)             //   ,  
    return(0);                //   ,     
// - 1 -  ==   ============================================================

// - 2 - ==          =======
   DeletePending();
// - 2 -  ==   ============================================================

// - 3 -  ==     ==============================================
   if (LastBar == Time[0])     //       
     return(1);                         //   ,      
// - 3 -  ==   ============================================================

// - 4 - ==      ========================================
   Tick = MarketInfo(Symbol(), MODE_TICKSIZE);                         //  
   Spread = ND(MarketInfo(Symbol(), MODE_SPREAD)*Point);                  //  
   StopLevel = ND(MarketInfo(Symbol(), MODE_STOPLEVEL)*Point);  //    
// - 4 -  ==   ============================================================
     
// - 5 - ==    =====================================================
   GetSignal();
// - 5 -  ==   ============================================================
   
// - 6 - ==     ===================================================
   if (Signal == 1)
     {
      int Res = CheckOrdersReal(OP_SELL);            //   - 
      if (Res == 0)                                          //    
        {
         if (!CheckPendingsReal(OP_BUYSTOP)) return(0);       //    
         RefreshRates();
         if (ND(Bid-SL-StopLevel) > 0)
           if (!OpenOrder(OP_BUY, ND(Ask), ND(SL), ND(TP), 0, Message)) //    
             return(1);                                //     
        }
      if(Res == 1) return(1); //   ,    
     }
// - 6 -  ==   ============================================================
     
// - 7 - ==    ===================================================
   if (Signal == 2)
     {
      Res = CheckOrdersReal(OP_BUY);                 //   - 
      if (Res == 0)                                          //    
        {
         if (!CheckPendingsReal(OP_SELLSTOP)) return(0);               //   SELL STOP
         RefreshRates();
         if (ND(SL-Ask-StopLevel) > 0)
           if (!OpenOrder(OP_SELL, ND(Bid), ND(SL), ND(TP), 0, Message))//    
             return(1);                                //     
        }
      if (Res == 1) return(1);//   ,     
     }
// - 7 -  ==   ============================================================

// - 8 - ==       ===========================
    if (!AddPending(Message)) return(1);
// - 8 -  ==   ============================================================

   LastBar = Time[0];                                            //   ""   return(1);
   return(1);
   }
   
//+-------------------------------------------------------------------------------------+
//|   K  B                              |
//|   Y = K*X + B,      ,           |
//|    K  B,   Y1, Y2, X1, X2                         |
//+-------------------------------------------------------------------------------------+
void DirectLineCalc(int XB, double YB, int XE, double YE, double &B, double &K) 
{
 B = (YB*XE - YE*XB)/(XE - XB);
 K = (YE - B)/XE;
} 

//+-------------------------------------------------------------------------------------+
//|    MACD  ,                             |
//+-------------------------------------------------------------------------------------+
void GetSignal()
{
 Signal = 0;                                                         //  
 
// - 1 - ==   MACD  1-4  ============================================
 double MACD1, MACD2, MACD3, MACD4, SMACD;
 MACD1 = iMACD(Symbol(), 0, FastMACD, SlowMACD, SignalMACD, PRICE_CLOSE, MODE_MAIN, 1);
 MACD2 = iMACD(Symbol(), 0, FastMACD, SlowMACD, SignalMACD, PRICE_CLOSE, MODE_MAIN, 2);
 MACD3 = iMACD(Symbol(), 0, FastMACD, SlowMACD, SignalMACD, PRICE_CLOSE, MODE_MAIN, 3);
 MACD4 = iMACD(Symbol(), 0, FastMACD, SlowMACD, SignalMACD, PRICE_CLOSE, MODE_MAIN, 4);
 SMACD = iMACD(Symbol(), 0, FastMACD, SlowMACD, SignalMACD, PRICE_CLOSE, MODE_SIGNAL, 1);
// - 1 - ==   =============================================================

// - 2 - ==   BUY =========================================================
 double DirectB = 0, DirectK = 0;
 if (SMACD < MACD1 && MACD1 < MACD2 && MACD2 > MACD3 && MACD3 > MACD4)   //   MACD
   if (FindFractals() == 1)                                  //   
     {                                      
      double ThirdFractal = DownFractal1;   //                       
      int ThirdNumber = TD1;                               //    
      DirectLineCalc(TU1, UpFractal1, TU2, UpFractal2, DirectB, DirectK); //  K  B
      double ParallelB = DownFractal1 - DirectK*TD1;    //  B   
      if (DownFractal2 < DirectK*TD2+ParallelB)//     
        {                  //   ,      
         ThirdFractal = DownFractal2;
         ThirdNumber = TD2;
         ParallelB = DownFractal2 - DirectK*TD2;
        }           
                   // ,         
      for (int i = MathMax(TD2, TU2); i >= MathMax(TD1, TU1); i--)
        if (Close[i] < DirectK*i+ParallelB || Close[i] > DirectK*i+DirectB)
          {
           DirectK = 0;                      //   ,    
           break;
          } 
      // ---------------
      if (DirectK != 0 && ND(Bid+StopLevel) < ND((DirectB+ParallelB)/2))
        {   //             
         TP = (DirectB-ParallelB)*Koeff+ParallelB;
         SL = ThirdFractal-2*Tick;
         Signal = 1;                                        //     BUY
        } 
     } 
// - 2 - ==   =============================================================

// - 3 - ==   SELL ========================================================
 if (SMACD > MACD1 && MACD1 > MACD2 && MACD2 < MACD3 && MACD3 < MACD4)   //   MACD
   if (FindFractals() == 2)                                  //   
     {
      ThirdFractal = UpFractal1;    //        
      ThirdNumber = TU1;                                        //   
      DirectLineCalc(TD1, DownFractal1, TD2, DownFractal2, DirectB, DirectK);    // K  B
      ParallelB = UpFractal1 - DirectK*TU1;//  B   
      if (UpFractal2 > DirectK*TU2+ParallelB)//      
        {                 //   ,      
         ThirdFractal = UpFractal2;
         ThirdNumber = TU2;
         ParallelB = UpFractal2 - DirectK*TU2;
        }           
                   // ,         
      for (i = MathMax(TD2, TU2); i >= MathMax(TD1, TU1); i--)
        if (Close[i] > DirectK*i+ParallelB || Close[i] < DirectK*i+DirectB)
          {
           DirectK = 0;                      //   ,    
           break;
          } 
      // ---------------
      if (DirectK != 0 && ND(Bid-StopLevel) > ND((DirectB+ParallelB)/2))
        {  //             
         SL = ThirdFractal + Spread + 2*Tick;
         TP = ParallelB - (ParallelB - DirectB)*Koeff+Spread;
         Signal = 2;                                       //     SELL
        }
     }   
// - 3 - ==   =============================================================
}  

//+-------------------------------------------------------------------------------------+
//|   .   ,   True,  - False    |
//+-------------------------------------------------------------------------------------+  
bool WaitForTradeContext()
{
 int P = 0;
 //  ""
 while(IsTradeContextBusy() && P < 5)
   {
    P++;
    Sleep(1000);
   }
 // -------------  
 if(P == 5)
   return(False);
 return(True);    
}
 
//+-------------------------------------------------------------------------------------+
//|       ,     |
//| (0 - , 1 - , 2 - )                                           |
//+-------------------------------------------------------------------------------------+
int FindFractals()
{
// - 1 - =======   ========================================================
   UpFractal1 = 0;
   UpFractal2 = 0;
   DownFractal1 = 0;
   DownFractal2 = 0;
   int i = 3;
   while ((UpFractal1 == 0 || UpFractal2 == 0 || DownFractal1 == 0 || DownFractal2 == 0)
           && i < Bars)   //  ,       
     {
      double Up = iFractals(Symbol(), 0, MODE_UPPER, i);               //  
      double Dn = iFractals(Symbol(), 0, MODE_LOWER, i);                //  
      if (Up != 0)                           //       
        if (UpFractal1 == 0)                    //      
          {
           UpFractal1 = Up;                                     //   
           TU1 = i;                                            //    
          } 
         else
          if (UpFractal2 == 0)           //       
            {
             UpFractal2 = Up;           //       
             TU2 = i;                                    //     
            } 
      if (Dn != 0)                            //       
        if (DownFractal1 == 0)                   //      
          { 
           DownFractal1 = Dn;                                   //   
           TD1 = i;                                            //    
          } 
         else
          if (DownFractal2 == 0)          //       
            {
             DownFractal2 = Dn;         //       
             TD2 = i;                                    //     
            }
      i++;
     }
// - 1 - =======   ========================================================
      
// - 2 - =======    ==========================================
   if (UpFractal1 == 0 || DownFractal1 == 0 ||       //      , 
       UpFractal2 == 0 || DownFractal2 == 0)//        -1
     {
      Print("  .     !");
      return(-1);
     }
     
   //  
   if(UpFractal1 > UpFractal2 && DownFractal1 > DownFractal2)
     return(1);   // 
     
   if(UpFractal1 < UpFractal2 && DownFractal1 < DownFractal2)
     return(2);   // 
// - 2 - =======   ========================================================
     
   return(0); //  
   // ------------------  
}  
 
//+-------------------------------------------------------------------------------------+
//|                                              |
//+-------------------------------------------------------------------------------------+
double ND(double A)
{
 return(NormalizeDouble(A, Digits));
}  

//+-------------------------------------------------------------------------------------+
//|                                                         |
//+-------------------------------------------------------------------------------------+
string ErrorToString(int Error)
{
 switch(Error)
   {
    case 2: return("  ,   ."); 
    case 5: return("    ,  ."); 
    case 6: return("   ,   ."); 
    case 64: return(" ,   .");
    case 132: return(" ."); 
    case 133: return(" ."); 
    case 149: return(" ."); 
   }
}
  
//+-------------------------------------------------------------------------------------+
//|                                                                      |
//| :                                                                         |
//|   True -                                                       |
//|   False -                                                             |
//+-------------------------------------------------------------------------------------+
bool OpenOrder(int Type, double Price, double SL, double TP, int Num, string& Message[])
{
 //     
 if(AccountFreeMarginCheck(Symbol(), OP_BUY, Lots) <= 0 || GetLastError() == 134) 
  {
   if(!FreeMarginAlert)
    {
     AG_Message(Message, "    . Free Margin = "+
           DoubleToStr(AccountFreeMargin(), 2));
     FreeMarginAlert = True;
    } 
   return(False);  
  }
 FreeMarginAlert = False;  
 // ---------------------------------------------

 switch (Type)
   {
    case OP_BUY: string S = "BUY"; break;
    case OP_SELL: S = "SELL"; break;
    case OP_BUYSTOP: S = "BUYSTOP"; break;
    case OP_SELLSTOP: S = "SELLSTOP"; break;
    case OP_BUYLIMIT: S = "BUYLIMIT"; break;
    case OP_SELLLIMIT: S = "SELLLIMIT"; break;
   }

 if(WaitForTradeContext())  //    
   {  
    AG_Message(Message, "     "+S+" ...");
    int ticket=OrderSend(Symbol(), Type, Lots, Price, 0, 
               SL, TP, Comm, MagicNumber*10+Num, 0, CLR_NONE);//  
    //     
    if(ticket<0)
      {
       int Error = GetLastError();
       if(Error == 2 || Error == 5 || Error == 6 || Error == 64 
          || Error == 132 || Error == 133 || Error == 149)//   
         {
          AG_Message(Message, "     . . "+
                   ErrorToString(Error)+"  !");
          FatalError = True;
         }
        else 
         AG_Message(Message, "   "+S+": "+Error);//  
       return(False);
      }
    // ---------------------------------------------
    
    //      
    AG_Message(Message, " "+S+"  !"); 
    return(True); 
    // ------------------------
   }
  else
   {
    AG_Message(Message, "     !");
    return(False);  
   } 
} 

//+-------------------------------------------------------------------------------------+
//|     Type.    ,   1.            |
//+-------------------------------------------------------------------------------------+
bool CheckPendingsReal(int Type)
{
 for (int i = OrdersTotal()-1; i >= 0; i--)
   if(OrderSelect(i, SELECT_BY_POS))
     if(OrderSymbol() == Symbol() && MathFloor(OrderMagicNumber()/10) == MagicNumber 
        && OrderType() > 2)                                   //   
       if(OrderType() == Type)                                    //    Type
         {
          if (WaitForTradeContext())  
            {
             if (!OrderDelete(OrderTicket()))                  //    
              return(False);                         //    -  False
            }  
           else
            return(False);// False,      
         }
        else
         return(False);        //  False,      Type
 return(True);                                             //   ,   True
}  


//+-------------------------------------------------------------------------------------+
//|     Type.     ,  1.             |
//|   ,   2.    0.              |
//+-------------------------------------------------------------------------------------+
int CheckOrdersReal(int Type)
{
 for (int i = OrdersTotal()-1; i >= 0; i--)
   if(OrderSelect(i, SELECT_BY_POS))
     if(OrderSymbol() == Symbol() && MathFloor(OrderMagicNumber()/10) == MagicNumber 
        && OrderType() < 2)                                       //  "" 
       if(OrderType() == Type)                                  //    Type
         {
          if (WaitForTradeContext())  
            {
             if(Type == OP_BUY)
               double Pr = ND(MarketInfo(Symbol(), MODE_BID));
              else
               Pr = ND(MarketInfo(Symbol(), MODE_ASK));
             if (!OrderClose(OrderTicket(), OrderLots(), Pr, 3))//    
              return(1);                                 //    -  1
            }  
           else
            return(1);// 1,       
         }
        else
         return(2);          //  2,   ,  
 return(0);                                                   //   ,   0
}  

//+-------------------------------------------------------------------------------------+
//|                                         |
//+-------------------------------------------------------------------------------------+
bool AddPending(string& Message[])
{
// - 1 - ==    =====================================================
 for (int i = OrdersTotal()-1; i >= 0; i--)
   if (OrderSelect(i, SELECT_BY_POS))
     if (OrderSymbol() == Symbol() && MathMod(OrderMagicNumber(), 10) == 0 
        && OrderType() < 2)     //    ,    
        {
         bool Res = False;     
         int Type = OrderType();                              //   
         double OpenP = OrderStopLoss();
         double TP = MathAbs(OrderOpenPrice()-OrderStopLoss());
         double SL = OrderTakeProfit();
// - 1 - ==   =============================================================

// - 2 - ==  ,        ==========
         for (int j = OrdersTotal()-1; j >= 0; j--)
            if (OrderSelect(j, SELECT_BY_POS))
              if (OrderSymbol() == Symbol() && MathMod(OrderMagicNumber(), 10) == 1 
                && OrderType() > 2)       
             {   
              Res = True;               //  ,    
              break;
             } 
// - 2 - ==   =============================================================

// - 3 - ==    ================================================
         if (!Res)                          //    ,   
           {
            if (Type == OP_BUY)                     //    , 
              {
               Type = OP_SELLSTOP;                             //  SELL STOP
               TP = OpenP - TP;      //         
              } 
             else
              {                                    //    , 
               Type = OP_BUYSTOP;                               //  BUY STOP
               TP = OpenP + TP;      //         
              } 
            if (!OpenOrder(Type, OpenP, SL, TP, 1, Message))//    
              return(False);                                          //  False
           }
// - 3 - ==   =============================================================
         break;
        }
 return(True);
}

//+-------------------------------------------------------------------------------------+
//|        ,   |
//+-------------------------------------------------------------------------------------+
void DeletePending()
{
 for (int i = OrdersTotal()-1; i >= 0; i--)
   if (OrderSelect(i, SELECT_BY_POS))
     if (OrderSymbol() == Symbol() && MathMod(OrderMagicNumber(), 10) == 1 
        && OrderType() > 2)                                   //   
        {
         bool Res = False;
         int Ticket = OrderTicket();
         //  ,  
         for (int j = OrdersTotal()-1; j >= 0; j--)
            if (OrderSelect(j, SELECT_BY_POS))
              if (OrderSymbol() == Symbol() && MathMod(OrderMagicNumber(), 10) == 0 
                && OrderType() < 2)                        
             {   
              Res = True;
              break;
             } 
         //   ,  
         if (!Res)
           OrderDelete(Ticket);
         // ------------------------------------   
         break;
        }
}

   
//    10 